"""
Simple tool to construct the model table from R's output.
"""

def main():
    # get model coefficients to extract
    fin = open("models/sample.csv", 'r')
    line = fin.readline().rstrip()
    cols = ["(Intercept)"] + line.split(',')
    fin.close()
    # parse R's output, generate CSV
    fin = open("models/models.txt", 'r')
    fout = open("models/models.csv", 'w')
    fout.write("var,form,rs,se,df,b0," + ','.join(cols[1:]) + '\n')
    while True:
        line = fin.readline()
        if line == "":
            break
        if line.startswith("[1]"):
            # found the next model
            form = line[5:-2]
            rs = fin.readline()[17:-2]
            se = fin.readline()[17:-2]
            df = fin.readline()[17:-2]
            cmap = dict([(v, "0") for v in cols])
            while True:
                # extract nonzero coefficients
                keys = fin.readline().split()
                if len(keys) == 0:
                    break
                vals = fin.readline().split()
                cmap.update(zip(keys, vals))
            # generate the output
            var = cols.index(form.split()[0])
            fout.write(','.join((str(var), form, rs, se, df, cmap[cols[0]])))
            for v in cols[1:]:
                fout.write(',' + cmap[v])
            fout.write('\n')
    fin.close()
    fout.close()


if __name__ == "__main__":
    main()
