/*
 * model.h - internal representation of the model table
 */

#ifndef __MODEL_H__
#define __MODEL_H__

#define FORM_LEN 60
#define MAX_VARS 4
#define MAX_MODS 508

typedef struct {
	int32 var;  /* response variable */
	char form[FORM_LEN]; /* model formula */
	float4 rs;  /* R-squared statistic */
	float4 se;  /* residual standard error */
	int32 df;   /* degrees of freedom */
	float4 b0;   /* intercept term */
	float4 ci[MAX_VARS]; /* intra-tuple coefficients */
	float4 cn[MAX_VARS]; /* neighbor coefficients */
} Model;

extern int32 g_nvar;
extern int32 g_nmod;
extern Model g_mods[MAX_MODS];

extern int16 g_round;
extern int32 g_updcnt;
extern int32 g_version;

void _PG_init(void);
int32 c_model_sync(char ext);

#endif /* __MODEL_H__ */
