--
-- model.c
--

CREATE FUNCTION model_sync()
RETURNS integer AS '$libdir/eracer'
LANGUAGE C VOLATILE;

CREATE FUNCTION model_sync(character)
RETURNS integer AS '$libdir/eracer'
LANGUAGE C VOLATILE;

CREATE FUNCTION set_round(integer)
RETURNS integer AS '$libdir/eracer'
LANGUAGE C VOLATILE STRICT;

CREATE FUNCTION set_version(integer)
RETURNS integer AS '$libdir/eracer'
LANGUAGE C VOLATILE STRICT;

COMMENT ON FUNCTION model_sync() IS 'loads models into local memory';
COMMENT ON FUNCTION model_sync(character) IS 'loads alternative model table';
COMMENT ON FUNCTION set_round(integer) IS 'updates the current round number';
COMMENT ON FUNCTION set_version(integer) IS 'sets variant of ERACER algorithm';

--
-- stats.c
--

CREATE FUNCTION erace_trans(state bytea, self node, next node)
RETURNS bytea AS '$libdir/eracer'
LANGUAGE C IMMUTABLE;

CREATE FUNCTION erace_final(state bytea)
RETURNS node AS '$libdir/eracer'
LANGUAGE C IMMUTABLE STRICT;

CREATE AGGREGATE erace(node, node) (
	SFUNC = erace_trans,
	STYPE = bytea,
	FINALFUNC = erace_final
);

COMMENT ON FUNCTION erace_trans(bytea, node, node) IS 'aggregate transition';
COMMENT ON FUNCTION erace_final(bytea) IS 'aggregate finalization';
COMMENT ON AGGREGATE erace(node, node) IS 'infers/cleans each basis';
