CREATE TABLE node (
  nid integer NOT NULL
  -- inferred values
);

/*
CREATE UNIQUE INDEX node__nid ON node (nid);
CLUSTER node USING node__nid;
ANALYZE VERBOSE node;
*/


CREATE TABLE link (
  dst integer NOT NULL, -- target node
  src integer NOT NULL, -- related node
  typ integer NOT NULL  -- type of link
);

/*
CREATE INDEX link__dst ON link (dst);
CREATE INDEX link__src ON link (src);
CLUSTER link USING link__dst;
ANALYZE VERBOSE link;
*/


CREATE TABLE model (
  var integer NOT NULL, -- response variable
  form varchar(59) NOT NULL, -- model formula
  rs real NOT NULL, -- R-squared statistic
  se real NOT NULL, -- residual standard error
  df integer NOT NULL, -- degrees of freedom
  b0 real NOT NULL -- intercept term
  -- intra-tuple coefficients
  -- neighbor coefficients
);


COMMENT ON TABLE node IS 'group of attributes to infer/clean';
COMMENT ON TABLE link IS 'relationship between two nodes';
COMMENT ON TABLE model IS 'linear regression coefficients';
